Index: palm/trunk/SOURCE/init_vertical_profiles.f90
===================================================================
--- palm/trunk/SOURCE/init_vertical_profiles.f90	(revision 3294)
+++ palm/trunk/SOURCE/init_vertical_profiles.f90	(revision 3294)
@@ -0,0 +1,148 @@
+!> @file ocean_mod.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2018 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! split from check_parameters as separate file to avoid circular dependency
+! with ocean_mod
+!
+! 
+!
+!
+! Authors:
+! --------
+! @author Siegfried Raasch
+!
+! Description:
+! ------------
+!> Inititalizes the vertical profiles of scalar quantities.
+!------------------------------------------------------------------------------!
+ SUBROUTINE init_vertical_profiles( vertical_gradient_level_ind,               &
+                                    vertical_gradient_level,                   &
+                                    vertical_gradient, initial_profile,        &
+                                    surface_value, bc_top_gradient )
+
+    USE arrays_3d,                                                             &
+        ONLY:  dzu, zu
+
+    USE control_parameters,                                                    &
+        ONLY:  ocean_mode
+
+    USE indices,                                                               &
+        ONLY:  nz, nzt
+
+    USE kinds
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i  !< loop counter
+    INTEGER(iwp) ::  k  !< loop counter
+    INTEGER(iwp), DIMENSION(1:10) ::  vertical_gradient_level_ind  !< vertical grid indices for gradient levels
+
+    REAL(wp)     ::  bc_top_gradient  !< model top gradient
+    REAL(wp)     ::  gradient         !< vertica gradient of the respective quantity
+    REAL(wp)     ::  surface_value    !< surface value of the respecitve quantity
+
+    REAL(wp), DIMENSION(0:nz+1) ::  initial_profile          !< initialisation profile
+    REAL(wp), DIMENSION(1:10)   ::  vertical_gradient        !< given vertical gradient
+    REAL(wp), DIMENSION(1:10)   ::  vertical_gradient_level  !< given vertical gradient level
+
+    i = 1
+    gradient = 0.0_wp
+
+    IF ( .NOT. ocean_mode )  THEN
+
+       vertical_gradient_level_ind(1) = 0
+       DO  k = 1, nzt+1
+          IF ( i < 11 )  THEN
+             IF ( vertical_gradient_level(i) < zu(k)  .AND.            &
+                  vertical_gradient_level(i) >= 0.0_wp )  THEN
+                gradient = vertical_gradient(i) / 100.0_wp
+                vertical_gradient_level_ind(i) = k - 1
+                i = i + 1
+             ENDIF
+          ENDIF
+          IF ( gradient /= 0.0_wp )  THEN
+             IF ( k /= 1 )  THEN
+                initial_profile(k) = initial_profile(k-1) + dzu(k) * gradient
+             ELSE
+                initial_profile(k) = initial_profile(k-1) + dzu(k) * gradient
+             ENDIF
+          ELSE
+             initial_profile(k) = initial_profile(k-1)
+          ENDIF
+!
+!--       Avoid negative values of scalars
+          IF ( initial_profile(k) < 0.0_wp )  THEN
+             initial_profile(k) = 0.0_wp
+          ENDIF
+       ENDDO
+
+    ELSE
+
+!
+!--    In ocean mode, profiles are constructed starting from the ocean surface,
+!--    which is at the top of the model domain
+       vertical_gradient_level_ind(1) = nzt+1
+       DO  k = nzt, 0, -1
+          IF ( i < 11 )  THEN
+             IF ( vertical_gradient_level(i) > zu(k)  .AND.            &
+                  vertical_gradient_level(i) <= 0.0_wp )  THEN
+                gradient = vertical_gradient(i) / 100.0_wp
+                vertical_gradient_level_ind(i) = k + 1
+                i = i + 1
+             ENDIF
+          ENDIF
+          IF ( gradient /= 0.0_wp )  THEN
+             IF ( k /= nzt )  THEN
+                initial_profile(k) = initial_profile(k+1) - dzu(k+1) * gradient
+             ELSE
+                initial_profile(k)   = surface_value - 0.5_wp * dzu(k+1) *     &
+                                                       gradient
+                initial_profile(k+1) = surface_value + 0.5_wp * dzu(k+1) *     &
+                                                       gradient
+             ENDIF
+          ELSE
+             initial_profile(k) = initial_profile(k+1)
+          ENDIF
+!
+!--       Avoid negative values of scalars
+          IF ( initial_profile(k) < 0.0_wp )  THEN
+             initial_profile(k) = 0.0_wp
+          ENDIF
+       ENDDO
+
+    ENDIF
+
+!
+!-- In case of no given gradients, choose zero gradient conditions
+    IF ( vertical_gradient_level(1) == -999999.9_wp )  THEN
+       vertical_gradient_level(1) = 0.0_wp
+    ENDIF
+!
+!-- Store gradient at the top boundary for possible Neumann boundary condition
+    bc_top_gradient  = ( initial_profile(nzt+1) - initial_profile(nzt) ) /     &
+                       dzu(nzt+1)
+
+ END SUBROUTINE init_vertical_profiles
Index: palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -92,5 +95,5 @@
                large_scale_forcing, large_scale_subsidence, lsf_surf, lsf_vert,&
                lsf_exception, message_string, nesting_offline, neutral,        &
-               nudging, passive_scalar, pt_surface, ocean, q_surface,          &
+               nudging, passive_scalar, pt_surface, ocean_mode, q_surface,     &
                surface_heatflux, surface_pressure, surface_waterflux,          &
                topography, use_subsidence_tendencies
@@ -696,7 +699,7 @@
        ENDIF
 
-       IF ( large_scale_forcing  .AND.  ocean )  THEN
+       IF ( large_scale_forcing  .AND.  ocean_mode )  THEN
           message_string = 'The usage of large scale forcing from external &'//&
-                        'file LSF_DATA is not implemented for ocean runs'
+                        'file LSF_DATA is not implemented for ocean mode'
           CALL message( 'check_parameters', 'PA0378', 1, 2, 0, 6, 0 )
        ENDIF
Index: palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- palm/trunk/SOURCE/lpm_init.f90	(revision 3291)
+++ palm/trunk/SOURCE/lpm_init.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -231,5 +234,5 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_droplets, constant_flux_layer, current_timestep_number,   &
-               dt_3d, dz, initializing_actions, message_string, ocean,         &
+               dt_3d, dz, initializing_actions, message_string, ocean_mode,    &
                simulated_time
 
@@ -328,5 +331,5 @@
 !-- In case of oceans runs, the vertical index calculations need an offset,
 !-- because otherwise the k indices will become negative
-    IF ( ocean )  THEN
+    IF ( ocean_mode )  THEN
        offset_ocean_nzt    = nzt
        offset_ocean_nzt_m1 = nzt - 1
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 3291)
+++ palm/trunk/SOURCE/modules.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3289 2018-09-28 10:23:58Z suehring
 ! +num_mean_inflow_profiles
 ! 
@@ -1109,5 +1112,4 @@
     CHARACTER (LEN=20)   ::  bc_s_b = 'dirichlet'                         !< namelist parameter
     CHARACTER (LEN=20)   ::  bc_s_t = 'initial_gradient'                  !< namelist parameter
-    CHARACTER (LEN=20)   ::  bc_sa_t = 'neumann'                          !< namelist parameter
     CHARACTER (LEN=20)   ::  bc_uv_b = 'dirichlet'                        !< namelist parameter
     CHARACTER (LEN=20)   ::  bc_uv_t = 'dirichlet'                        !< namelist parameter
@@ -1180,5 +1182,4 @@
     INTEGER(iwp) ::  ibc_s_b                           !< integer flag for bc_s_b
     INTEGER(iwp) ::  ibc_s_t                           !< integer flag for bc_s_t
-    INTEGER(iwp) ::  ibc_sa_t                          !< integer flag for bc_sa_t
     INTEGER(iwp) ::  ibc_uv_b                          !< integer flag for bc_uv_b
     INTEGER(iwp) ::  ibc_uv_t                          !< integer flag for bc_uv_t
@@ -1242,5 +1243,4 @@
     INTEGER(iwp) ::  q_vertical_gradient_level_ind(10) = -9999   !< grid index values of q_vertical_gradient_level(s)
     INTEGER(iwp) ::  s_vertical_gradient_level_ind(10) = -9999   !< grid index values of s_vertical_gradient_level(s)   
-    INTEGER(iwp) ::  sa_vertical_gradient_level_ind(10) = -9999  !< grid index values of sa_vertical_gradient_level(s)
     INTEGER(iwp) ::  section(100,3)                              !< collective array for section_xy/xz/yz
     INTEGER(iwp) ::  section_xy(100) = -9999                     !< namelist parameter
@@ -1293,5 +1293,5 @@
     LOGICAL ::  constant_top_heatflux = .TRUE.                   !< heat flux at domain top constant?
     LOGICAL ::  constant_top_momentumflux = .FALSE.              !< momentum flux at domain topconstant?
-    LOGICAL ::  constant_top_salinityflux = .TRUE.               !< salinity flux at ocean domain top?
+    LOGICAL ::  constant_top_salinityflux = .TRUE.               !< constant salinity flux at ocean surface
     LOGICAL ::  constant_top_scalarflux = .TRUE.                 !< passive-scalar flux at domain top constant?
     LOGICAL ::  constant_scalarflux = .TRUE.                     !< passive-scalar flux at surfaces constant?
@@ -1328,5 +1328,5 @@
     LOGICAL ::  neutral = .FALSE.                                !< namelist parameter
     LOGICAL ::  nudging = .FALSE.                                !< namelist parameter
-    LOGICAL ::  ocean = .FALSE.                                  !< namelist parameter
+    LOGICAL ::  ocean_mode = .FALSE.                             !< namelist parameter
     LOGICAL ::  passive_scalar = .FALSE.                         !< namelist parameter
     LOGICAL ::  plant_canopy = .FALSE.                           !< switch for use of plant canopy model
@@ -1380,5 +1380,5 @@
                                                                !< (galilei transformation)
     REAL(wp) ::  alpha_surface = 0.0_wp                        !< namelist parameter
-    REAL(wp) ::  atmos_ocean_sign = 1.0_wp                     !< vertical-grid conversion factor 
+    REAL(wp) ::  atmos_ocean_sign = 1.0_wp                     !< vertical-grid conversion factor
                                                                !< (=1.0 in atmosphere, =-1.0 in ocean)
     REAL(wp) ::  averaging_interval = 0.0_wp                   !< namelist parameter
@@ -1454,5 +1454,4 @@
     REAL(wp) ::  particle_maximum_age = 9999999.9_wp           !< namelist parameter
     REAL(wp) ::  prandtl_number = 1.0_wp                       !< namelist parameter
-    REAL(wp) ::  prho_reference                                !< reference state of potential density
     REAL(wp) ::  pt_damping_factor = 0.0_wp                    !< namelist parameter
     REAL(wp) ::  pt_damping_width = 0.0_wp                     !< namelist parameter
@@ -1472,5 +1471,4 @@
     REAL(wp) ::  rho_surface                                   !< surface value of density
     REAL(wp) ::  roughness_length = 0.1_wp                     !< namelist parameter
-    REAL(wp) ::  sa_surface = 35.0_wp                          !< namelist parameter
     REAL(wp) ::  simulated_time = 0.0_wp                       !< elapsed simulated time
     REAL(wp) ::  simulated_time_at_begin                       !< elapsed simulated time of previous run (job chain)
@@ -1550,6 +1548,4 @@
     REAL(wp) ::  s_vertical_gradient(10) = 0.0_wp                  !< namelist parameter
     REAL(wp) ::  s_vertical_gradient_level(10) = -999999.9_wp    !< namelist parameter
-    REAL(wp) ::  sa_vertical_gradient(10) = 0.0_wp                 !< namelist parameter
-    REAL(wp) ::  sa_vertical_gradient_level(10) = -999999.9_wp   !< namelist parameter
     REAL(wp) ::  skip_time_domask(max_masks) = 9999999.9_wp        !< namelist parameter
     REAL(wp) ::  threshold(20) = 0.0_wp                            !< namelist parameter
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -568,6 +571,6 @@
                do3d_time_count, domask_time_count, end_time, land_surface,     &
                mask_size_l, mask_i, mask_i_global, mask_j, mask_j_global,      &
-               mask_k_global, message_string, mid, ntdim_2d_xy,                &
-               ntdim_2d_xz, ntdim_2d_yz, ntdim_3d, nz_do3d, plant_canopy,      &
+               mask_k_global, message_string, mid, ntdim_2d_xy, ntdim_2d_xz,   &
+               ntdim_2d_yz, ntdim_3d, nz_do3d, ocean_mode, plant_canopy,       &
                run_description_header, section, simulated_time,                &
                simulated_time_at_begin, skip_time_data_output_av,              &
@@ -589,4 +592,7 @@
     USE land_surface_model_mod,                                                &
         ONLY: lsm_define_netcdf_grid, nzb_soil, nzt_soil, nzs, zs
+
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_define_netcdf_grid
 
     USE pegrid
@@ -943,5 +949,5 @@
                 CASE ( 'e', 'lpt', 'nc', 'nr', 'p', 'pc', 'pr', 'prr', 'pt',   &
                        'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
-                       'rho_ocean', 's', 'sa', 'vpt'  )
+                       's', 'vpt'  )
 
                    grid_x = 'x'
@@ -971,23 +977,33 @@
 
 !             
-!--       Block of urban surface model outputs   
+!--             Block of urban surface model outputs
                 CASE ( 'usm_output' )
 
-                   CALL usm_define_netcdf_grid( domask(mid,av,i), found, &
+                   CALL usm_define_netcdf_grid( domask( mid,av,i), found,      &
                                                         grid_x, grid_y, grid_z )
 
                 CASE DEFAULT
-
-                   CALL tcm_define_netcdf_grid( domask(mid,av,i), found, &
-                                                        grid_x, grid_y, grid_z )
-
-!
-!--                Check for land surface quantities
+!
+!--                Check for quantities defined in other modules
+                   IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                      CALL chem_define_netcdf_grid( domask(mid,av,i), found,   &
+                                                    grid_x, grid_y, grid_z )
+                   ENDIF
+
+                   IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
+                      CALL gust_define_netcdf_grid( domask(mid,av,i), found,   &
+                                                    grid_x, grid_y, grid_z )
+                   ENDIF
+
                    IF ( land_surface )  THEN
                       CALL lsm_define_netcdf_grid( domask(mid,av,i), found,    &
                                                    grid_x, grid_y, grid_z )
                    ENDIF
-!
-!--                Check for plant canopy quantities
+
+                   IF ( .NOT. found  .AND.  ocean_mode )  THEN
+                      CALL ocean_define_netcdf_grid( domask(mid,av,i), found,  &
+                                                     grid_x, grid_y, grid_z )
+                   ENDIF
+
                    IF ( .NOT. found  .AND.  plant_canopy )  THEN
                       CALL pcm_define_netcdf_grid( domask(mid,av,i), found,    &
@@ -995,6 +1011,4 @@
                    ENDIF
 
-!
-!--                Check for radiation quantities
                    IF ( .NOT. found  .AND.  radiation )  THEN
                       CALL radiation_define_netcdf_grid( domask(mid,av,i),     &
@@ -1003,21 +1017,9 @@
                    ENDIF
 
-!
-!--                Check for gust module quantities
-                   IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
-                      CALL gust_define_netcdf_grid( domask(mid,av,i), found,   &
-                                                    grid_x, grid_y, grid_z )
-                   ENDIF
-
-!
-!--                Check for chemistry quantities                   
-                   IF ( .NOT. found  .AND.  air_chemistry )  THEN
-                      CALL chem_define_netcdf_grid( domask(mid,av,i),          &
-                                                    found, grid_x, grid_y,     &
-                                                    grid_z )
-                   ENDIF
-
-!
-!--                Check for user-defined quantities
+                   CALL tcm_define_netcdf_grid( domask( mid,av,i), found,      &
+                                                        grid_x, grid_y, grid_z )
+
+!
+!--                Now check for user-defined quantities
                    IF ( .NOT. found )  THEN
                       CALL user_define_netcdf_grid( domask(mid,av,i), found,   &
@@ -4806,5 +4808,5 @@
 !
 !--       Define y-axis
-          CALL netcdf_create_dim(id_set_sp, 'k_y', ny/2, id_dim_y_sp, 282 )
+          CALL netcdf_create_dim( id_set_sp, 'k_y', ny/2, id_dim_y_sp, 282 )
           CALL netcdf_create_var( id_set_sp, (/ id_dim_y_sp /), 'k_y',         &
                                   NF90_DOUBLE, id_var_y_sp, 'm-1', '', 283,    &
